#include <stdlib.h>
#include <string.h>	
#include <avr/io.h>
#include <avr/pgmspace.h>	
#include <avr/interrupt.h>			

#define F_CPU 8000000
#include <util/delay.h>


unsigned char rstr[13];				// fat string bearbeitet ; pgm string tmp

unsigned char command[5];			// commando (größtes : "cd..")
unsigned char data[13];				// maximal 8.3 bei datei namen !


//*****************************************************************************************************************
#include "usart32-0.1.h"
#include "mmc-0.1.c"
#include "fat-0.1.c"
#include "file-0.1.c"
#include "lcd-0.1.h"

//*****************************************************************************************************************

unsigned char 	run_cmd(void);							// zeigt commando prompt
unsigned char 	fat_str(unsigned char str[]);			// wandelt z.b. "t.txt" in "T        TXT" und speichert auf rstr
unsigned char 	cmd_data(unsigned char string[]);		// zerlegt z.b. "cd dir1" in commando "cd" und data "dir1"		
unsigned char*	strings (PGM_P str) __ATTR_CONST__;		// legt strings im programm speicher ab

/*
// ***********************************************************
// benchmark timer0 atmega32 @ 8mhz (ms tick)
// ***********************************************************
unsigned int 	i=0;	//ms
unsigned char 	j=0;	//sekunden
unsigned char 	n=0;	//minuten

ISR(TIMER0_COMP_vect){

	i++;

	if(i==1000){
		j++;
		i=0;
		}

	if(j==60){
		j=0;
		n=1;	
		}
}
*/

//*****************************************************************************************************************
int main(void){

  uinit(); 
  lcd_init();

  while (mmc_init() !=0){ 			//ist der Rückgabewert ungleich NULL ist ein Fehler aufgetreten	
	;	
	} 

  if(0==fat_initfat()){
	uputs((char *)strings(PSTR("\n\rBoot... Ok\n\r")));	
	lcd_string((char *)strings(PSTR("Boot... Ok")));
/*	
	fat_str("dir1");
	ffcd(rstr);
	ffcd(rstr);
	fat_str("dir3");
	ffcd(rstr);
	fat_str("mmc.c");	
	  
	// timer an !
	OCR0 =125;									//125
	TIMSK |= (1<<OCIE0);						// compare interrupt an
	TCCR0 |= (1<<WGM01)|(1<<CS01)|(1<<CS00);	// ctc mode, prescaler 64	
	sei();


	ffopen('r',rstr);
	unsigned char c;	
	do{
	  c=ffread();
	  }while(--seek);
	
	// timer aus !
	TCCR0 &= ~( (1<<CS01)|(1<<CS00) );	

	ffclose();

	// uart-> timer werte anzeigen
	uputs("\n\rm:");
	uputs(utoa(n,rstr,10));
	uputs(" s:");	
	uputs(utoa(j,rstr,10));
	uputs(" ms:");	
	uputs(utoa(i,rstr,10));
	uputs("\n\r");		
*/	
	run_cmd();						// zeigt command promt	  		
	}

  return (1);
}


//***********************************************************
unsigned char* strings (PGM_P str){
	return (unsigned char *)strcpy_P((char *)rstr,str);	
}


// *****************************************************************************************************************
unsigned char fat_str(unsigned char str[]){
  // 1. prüft ob gesammter string zu groß.
  // 2. prüft auf stellen nach dem punkt (max 3).
  // 3. prüft auf stellen vor dem punkt (max 8).
  // 4. pruft auf mehrere punkte. es ist max 1 punkt erlaubt.

  if(strlen(str)>12)	return(1);	// string zu groß, abbruch !!
  
  unsigned char i=0;				// zähler für string.
  unsigned char j=0;  				// zähler für str.
  unsigned char c;					// zeichen aus str, wird so gemacht, um die zeichen prüfen zu können.
  unsigned char dot=0;				// stelle des punktes.
  unsigned char string[13];   

  strupr((char*)str);				// a-z -> A-Z
    
  do{
	c = str[j];		
	
	if(c=='.'){						// punkt weglassen !!	
	  if(dot!=0) return (4);		// mehr als 1 punkt, abbruch !!
	  dot=i;						// punkt vorhanden, an stelle i.
 	  j++;							// nächstes zeichen in strn (nach '.').
	  continue;						// springt hoch, um den '.' nicht auf string zu schreiben !
	  }	

	if(dot!=0 && i<8){				// muss mit leerzeichen aufgefüllt werden (immer 8.3).
	  c=' ';						// leerzeichen (0x20).
	  j--;							// j wird zurück gesetzt, um aus dem orginal string noch nicht den nächsten c zu holen,
	  }								// da erst mit leerzeichen aufgefüllt werden muss !	
					
	if(dot!=0 && (dot+4)==j) return(2);	// zu viele stellen nach dem punkt, abbruch !!
	if(i>7 && dot==0)		 return(3);	// zu viele stellen im namen, abbruch !!  	

	string[i] = c;					// zeichen aus str auf string schreiben.
	i++;							// zähler für string.
	j++;							// zähler für str.
  }while(str[j]!='\0');

  for(;i<11;i++)string[i]=' ';		// mit leerzeichen auffüllen, ab dem letzten zeichen, bei ordnern, 3 zeichen sonst bis zu 2.
  string[i]='\0';					// abschluss des strings.
  
  strcpy(rstr,string);				// arbeitsstring auf globalen kopieren.	

  return(0);

}


// *****************************************************************************************************************
unsigned char cmd_data(unsigned char string[]){
	
  if(15<strlen(string)) return (1);				// fehler, string zu groß.

  unsigned char i=0;    
  unsigned char *str=&string[0];				// pointer auf string.
  unsigned char *space= strchr(string,(int)' ');// trennzeichen, wenn vorhanden.
	
  do{
  
	if(space==NULL){						// kein trennzeichen, also nur kommando.
	  command[i]=*str;
	  }
	 
	else{									// trennzeichen da, also kommando und data.
	  if(str<space)  command[i]=*str;		// kommando vor trennzeichen . 
	  if(str==space) {
		command[i]='\0';					// abschluss commando string (data weiter unten !!).
		i=-1;								// trennzeichen (-1 weil in schleife eins hochgezählt wird).			 
		}
	  if(str>space)  data[i]=*str;			// daten nach trennzeichen. 
	  }
  
  str++;
  i++;
  }while(*str!='\0');
  
  if(space!=0)data[i]='\0';					// string abschluss wenn cmd und data (command weiter oben!).
  else {									// string abschluss wenn nur cmd (data[0]='\0' !!).
	command[i]='\0';
	data[0]='\0';
	}
  return(0);
}


// *****************************************************************************************************************
unsigned char run_cmd(void){						
  
  char cmd_str[15];		
  char directory[50];	
  char flag=0;
  unsigned char c;
  unsigned char i=0;
 
  strcpy(directory,"dan:");	

  do{
	uputs("\n\r");
	uputs(directory);
	uputs(" >:");						// command prompt	

	while(c!=13 && i<15){
	  c=ugetc();			  			// liest zeichen ein, maximal 15				 
	  uputc(c);							// gibt zeichen aus (uart)	  
	  cmd_str[i]=c;
	  i++;
	  }

	cmd_str[i-1]='\0';
	i=0;
	c=0;

	cmd_data(cmd_str);				// teilt string in befehl und parameter(daten) auf

		// cd ************************************************************************************************* 
		if(0==strcmp(command,"cd")&&flag==0){			// befehl cd erkannt	
		  if(0==fat_str(data)){								// bereitet string auf, mit prüfungen.		
			if(0==ffcd(rstr)){								// wechselt in directory.
 			  strcat(directory,"/");									
 			  strcat(directory,data);						// zeigt dir an
			  }	
			}
		  }

		// cd.. *************************************************************************************************
		if(0==strcmp(command,"cd..")&&flag==0){			// befehl cd.. erkannt	
		  if(0==ffcdLower()) {								// geht in partent dir
 			char *ptr;										// zeigt auf letzte stelle an der / vorkommt	
 			ptr=strrchr(directory,'/');						// letztes vorkommen von /
 			*ptr = '\0' ;									// stelle von letztem / wird mit \0 überschrieben	
			}	
		  }	

		// rm *************************************************************************************************
		if(0==strcmp(command,"rm")&&flag==0){			// befehl remove	
		  if(0==fat_str(data)){								// bereitet string auf, mit prüfungen.					
			if(0==ffrm(rstr)){								// löscht datei			  
			  }	
			}
		  }

		// or *************************************************************************************************
		if(0==strcmp(command,"or")&&flag==0){			// befehl open to read erkannt	
		  if(0==fat_str(data)){								// bereitet string auf, mit prüfungen.					
			if(0==ffopen('r',rstr)){						// öffnet datei zum lesen
 			  strcat(directory,"/");
 			  strcat(directory,data);						// zeigt dir an						
 			  flag=1;										// flag==1 -> datei lesen
			  }	
			}
		  }

		// ow *************************************************************************************************
		if(0==strcmp(command,"ow")&&flag==0){			// befehl open to write erkannt	
		  if(0==fat_str(data)){								// bereitet string auf, mit prüfungen.					
			if(0==ffopen('w',rstr)){						// öffnet datei zum schreiben
 			  strcat(directory,"/");
 			  strcat(directory,data);						// zeigt dir an											
			  flag=2;										// flag==2 -> datei schreiben					
			  }	
			}
		  }

		 // oa *************************************************************************************************
		if(0==strcmp(command,"oa")&&flag==0){				// befehl open to append erkannt	
		  if(0==fat_str(data)){								// bereitet string auf, mit prüfungen.					
			if(0==ffopen('a',rstr)){						// öffnet datei zum anhängen
			  strcat(directory,"/");
			  strcat(directory,data);						// zeigt dir an											
			  flag=3;										// flag==3 -> datei anhängen					
			  }	
			}
		  }

		// w *************************************************************************************************
		if(0==strcmp(command,"w")&&flag>1){			// befehl write erkannt, geht nur wenn zum schreiben geöffnet.
			unsigned char c;
			uputs("\n\r>\n\r");			
			do{				
				c=ugetc();
				if(c==27)break;
				ffwrite(c);										
				uputc(c);
				}while(1);			
			uputs("\n\r<");			
			}

		// c *************************************************************************************************
		if(0==strcmp(command,"c")&&flag!=0){			// befehl close erkannt				
			if(0==ffclose() ){
 				char *ptr;									// siehe oben !
 				ptr=strrchr(directory,(int)'/');
 				*ptr = '\0' ;					
				flag=0;				
				}	
			}

		// ls *************************************************************************************************
		if(0==strcmp(command,"ls")&&flag<2){			// befehl ls , 2 optionen: 1. datei inhalt 2. directory anzeigen.
		  uputs("\n\r");
		  if(flag==1){									// datei geöffnet, nun lesen !
			do{											// wiederholt so lange wie bytes da sind.													
			  uputc(ffread());				  
			  }while(--seek);
			  uputs("\n\r");
			}

		  if(flag==0){									// directory anzeigen
			if(0==ffls());						
			}
		  }		

  }while(cmd_str[0]!=27 && strcmp(cmd_str,"q"));
  return (0);
}





/*unsigned char *x __attribute__ ((section ("bar")));

void foo1 (void)
{
    *x = 0x42;
}

// *************************************************************
extern unsigned char *bazz;

void foo2 (void)
{
    *bazz = 0x42;
}
// *************************************************************
#define P (*((unsigned char**) (&GPIOR0)))

void foo3 (void)
{
    *P = 0x42;
}
// *************************************************************

register unsigned char p asm("r3");	

void foo4 (void){

p= 0x42;


}

unsigned char pt;

void foo5 (void){

pt= 0x42;


}

*/



